﻿using UnityEngine;
using System.Collections;
using com.xsj.Crasheye.U3D;
using System.Runtime.InteropServices;

public class CrasheyeForIOS : MonoBehaviour
{
#if UNITY_IPHONE

    [DllImport("__Internal")]
	private static extern void crasheyeInit(string appkey);
	
	[DllImport("__Internal")]
	private static extern void crasheyeInitWithChannel(string appkey, string channel);
	
	[DllImport("__Internal")]
	private static extern void crasheyeAddExtraData(string key, string value);
	
	[DllImport("__Internal")]
	private static extern void crasheyeRemoveExtraData(string key);
	
	[DllImport("__Internal")]
	private static extern void crasheyeClearExtraData();
	
	[DllImport("__Internal")]
	private static extern void crasheyeLeaveBreadcrumb(string breadcrumb);
	
	[DllImport("__Internal")]
	private static extern void crasheyeSetUserid(string userid);
            
    /// <summary>
    /// iOS系统的初始
    /// </summary>
    /// <param name="appKeyForIOS"></param>
    /// <param name="channIdForIOS"></param>
    public static void Init(string appKeyForIOS, string channIdForIOS)
    {
        crasheyeInitWithChannel(appKeyForIOS, channIdForIOS);

        Crasheye.crasheyeLib.InitCrasheyeLib();        
        Crasheye.crasheyeLib.SetExceptionCallback();
    }
    
    /// <summary>
    /// 设置是否打印调试日志
    /// </summary>
    /// <param name="debugLog">默认为False为不打印日志；True为打印日志</param>
    public static void SetDebugLog(bool debugLog)
    {
        // 暂时未实现
    }

    /// <summary>
    /// 设置版本号信息
    /// </summary>
    /// <param name="appVersion"></param>
    public static void SetAppVersion(string appVersion)
    {
        // 暂时未实现
    }

    public static void SetFlushOnlyOverWiFi(bool enabled)
    {
        // 暂时未实现
    }

    /// <summary>
    /// 添加自定义数据
    /// </summary>
    /// <param name="key">Key.</param>
    /// <param name="value">Value.</param>
    public static void AddExtraData(string key, string value)
    {
        crasheyeAddExtraData(key, value);
    }

    /// <summary>
    /// 获取自定义数据
    /// </summary>
    /// <param name="key">Key</param>
    public static string GetExtraData(string key)
    {
        // 暂时未实现
        return "";
    }

    /// <summary>
    /// 移除自定义数据
    /// </summary>
    /// <param name="key">Key.</param>
    public static void RemoveExtraData(string key)
    {
        crasheyeRemoveExtraData(key);
    }

    /// <summary>
    /// 添除数据
    /// </summary>
    public static void ClearExtraData()
    {
        crasheyeClearExtraData();
    }

    /// <summary>
    /// 打点数据
    /// </summary>
    /// <param name="breadcrumb">Breadcrumb.</param>
    public static void LeaveBreadcrumb(string breadcrumb)
    {
        crasheyeLeaveBreadcrumb(breadcrumb);
    }
#endif
}
